// Copyright (c) Lawrence Livermore National Security, LLC and other VisIt
// Project developers.  See the top-level LICENSE file for dates and other
// details.  No copyright assignment is required to contribute to VisIt.

// ************************************************************************* //
//                          avtNASTRANOptions.h                              //
// ************************************************************************* //

#ifndef AVT_NASTRAN_OPTIONS_H
#define AVT_NASTRAN_OPTIONS_H

class DBOptionsAttributes;

#include <string>

namespace NASTRANDBOptions
{
    // Read options
    const char *const NASTRAN_RDOPT_MAT_COUNT = "Num Materials (-1==costly search)";
}

// ****************************************************************************
//  Functions: avtNASTRANOptions
//
//  Purpose:
//      Creates the options for  NASTRAN readers and/or writers.
//
//  Programmer: miller -- generated by xml2avt
//  Creation:   Thu Nov 29 14:10:56 PST 2007
//
// ****************************************************************************

DBOptionsAttributes *GetNASTRANReadOptions(void);
DBOptionsAttributes *GetNASTRANWriteOptions(void);


#endif
