// Copyright (c) Lawrence Livermore National Security, LLC and other VisIt
// Project developers.  See the top-level LICENSE file for dates and other
// details.  No copyright assignment is required to contribute to VisIt.

// ************************************************************************* //
//                             avtProteinDataBankOptions.C                              //
// ************************************************************************* //

#include <avtProteinDataBankOptions.h>

#include <DBOptionsAttributes.h>

#include <string>


// ****************************************************************************
//  Function: GetProteinDataBankReadOptions
//
//  Purpose:
//      Creates the options for ProteinDataBank readers.
//
//  Important Note:
//      The code below sets up empty options.  If your format 
//      does not require read options, no modifications are 
//      necessary.
//
//  Programmer: js9 -- generated by xml2avt
//  Creation:   Fri Mar 17 09:25:34 PDT 2006
//
// ****************************************************************************

DBOptionsAttributes *
GetProteinDataBankReadOptions(void)
{
    DBOptionsAttributes *rv = new DBOptionsAttributes;
    return rv;
/* EXAMPLE OF OPTIONS
    rv->SetBool("Binary format", true);
    rv->SetBool("Big Endian", false);
    rv->SetEnum("Dimension", 1);
    vector<string> dims;
    dims.push_back("0D");
    dims.push_back("1D");
    dims.push_back("2D");
    dims.push_back("3D");
    rv->SetEnumStrings(2, dims);
    rv->SetInt("Number of variables", 5);
    rv->SetString("Name of auxiliary file", );
    rv->SetDouble("Displacement factor", 1.0);

    // When reading or writing the file, you can get the options out of this object like:
    rv->GetDouble("Displacement factor");
*/
}


// ****************************************************************************
//  Function: GetProteinDataBankWriteOptions
//
//  Purpose:
//      Creates the options for ProteinDataBank writers.
//
//  Important Note:
//      The code below sets up empty options.  If your format 
//      does not require write options, no modifications are 
//      necessary.
//
//  Programmer: js9 -- generated by xml2avt
//  Creation:   Fri Mar 17 09:25:34 PDT 2006
//
// ****************************************************************************

DBOptionsAttributes *
GetProteinDataBankWriteOptions(void)
{
    DBOptionsAttributes *rv = new DBOptionsAttributes;
    return rv;
}
