// Copyright (c) Lawrence Livermore National Security, LLC and other VisIt
// Project developers.  See the top-level LICENSE file for dates and other
// details.  No copyright assignment is required to contribute to VisIt.

// ************************************************************************* //
//                            avtSARFileFormat.h                           //
// ************************************************************************* //

#ifndef AVT_SAR_FILE_FORMAT_H
#define AVT_SAR_FILE_FORMAT_H

#include <avtSTSDFileFormat.h>


// ****************************************************************************
//  Class: avtSARFileFormat
//
//  Purpose:
//      Reads in SAR files as a plugin to VisIt.
//
//  Programmer: childs -- generated by xml2avt
//  Creation:   Mon Jan 24 14:44:37 PST 2005
//
// ****************************************************************************

class avtSARFileFormat : public avtSTSDFileFormat
{
  public:
                       avtSARFileFormat(const char *filename);
    virtual           ~avtSARFileFormat() {;};

    virtual const char    *GetType(void)   { return "SAR"; };
    virtual void           FreeUpResources(void); 

    virtual vtkDataSet    *GetMesh(const char *);
    virtual vtkDataArray  *GetVar(const char *);
    virtual vtkDataArray  *GetVectorVar(const char *);

  protected:
    int nX, nY, nZ;

    virtual void           PopulateDatabaseMetaData(avtDatabaseMetaData *);
};


#endif
